###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

from lib.Engine import Engine
import pygame, sys, os

from game.intro.MainMenu import MainMenu
from game.selectPlayer.SelectPlayer import SelectPlayer
from game.selectMode.SelectMode import SelectMode
from game.freeMode.FreeMode import FreeMode
from game.pauseMenu.PauseMenu import PauseMenu
import constants

from game.configMenu.ConfigMenu import ConfigMenu


class Arcadia(Engine):

    def __init__(self):
        self.screen_width = 1024
        self.screen_height = 600
        self.tileSize = 48
        self.ticks = 30
        self.title_game = "Arcadia"
        self.flags = 0
        

        #we call parent constructor
        Engine.__init__(self)
        self.games.append(MainMenu(self))
        self.games.append(SelectPlayer(self))
        self.games.append(SelectMode(self))
        self.games.append(FreeMode(self))
        self.games.append(ConfigMenu(self))
        self.games.append(PauseMenu(self))

        #iniciamos MainMenu por defecto
        self.game = self.games[0]
        
    def paint(self):
        self.game.paint()
        self.renderManager.paintGUI(self.gui.getGUI())

    def logic(self):
        if not self.pause:
            self.game.logic()

    def controls(self):
        self.game.controls()
        

if __name__ == "__main__":

    #start game
    game = Arcadia()
    game.mainLoop()



