###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import pygame
import os, sys
from lib.ConfigManager import ConfigHandler
from Game import Game
from game.intro.Fondo import Fondo
from lib.Shadows import *
from lib.SimpleSurface import SimpleSurface


class PauseMenu(Game):

    def __init__(self, core):

        Game.__init__(self,core)
        self.core = core
        self.core.font.selectCustomFont("kimbalt_", 30)


        #INFORMATION
        self.titulo = self.core.font.renderText("Pausa:", self.core.screen_width * 0.01, self.core.screen_height * 0.05, (0,153,255))
        sombra = add_shadow(self.titulo.getSurface(), (2,2))
        self.titulo.setSurface(sombra)

        #self.fondo = Fondo(self.core, (0,0))
        #self.fondo2 = Fondo(self.core, (self.core.screen_width, 0))

        self.barra_superior = SimpleSurface("game"+os.path.sep+"configMenu"+os.path.sep+"images"+os.path.sep+"barra_superior"+os.path.sep+"barra_superior.png")



        #FONTS
        self.core.font.selectCustomFont("kimbalt_", 48)

        color=(255,255,255)
        self.resume = self.core.font.renderText("Reanudar", self.core.screen_width * 0.2, self.core.screen_height * 0.3, color)
        sombra = add_shadow(self.resume.getSurface(), (2,2))
        self.resume.setSurface(sombra)

        self.selectedResume = self.core.font.renderText("Reanudar", self.core.screen_width * 0.2, self.core.screen_height * 0.3, (255,0,0))
        sombra = add_shadow(self.selectedResume.getSurface(), (2,2))
        self.selectedResume.setSurface(sombra)


        self.opt = self.core.font.renderText("Opciones", self.core.screen_width * 0.2, self.core.screen_height * 0.4, color)
        sombra = add_shadow(self.opt.getSurface(), (2,2))
        self.opt.setSurface(sombra)

        self.selectedOpt = self.core.font.renderText("Opciones", self.core.screen_width * 0.2, self.core.screen_height * 0.4, (255,0,0))
        sombra = add_shadow(self.selectedOpt.getSurface(), (2,2))
        self.selectedOpt.setSurface(sombra)



        self.mainmenu = self.core.font.renderText("Menu Principal", self.core.screen_width * 0.2, self.core.screen_height * 0.5, color)
        sombra = add_shadow(self.mainmenu.getSurface(), (2,2))
        self.mainmenu.setSurface(sombra)

        self.selectedMainMenu = self.core.font.renderText("Menu Principal", self.core.screen_width * 0.2, self.core.screen_height * 0.5, (255,0,0))
        sombra = add_shadow(self.selectedMainMenu.getSurface(), (2,2))
        self.selectedMainMenu.setSurface(sombra)



        self.quit = self.core.font.renderText("Salir del juego", self.core.screen_width * 0.2, self.core.screen_height * 0.7, color)
        sombra = add_shadow(self.quit.getSurface(), (2,2))
        self.quit.setSurface(sombra)

        self.selectedQuit = self.core.font.renderText("Salir del juego", self.core.screen_width * 0.2, self.core.screen_height * 0.7, (255,0,0))
        sombra = add_shadow(self.selectedQuit.getSurface(), (2,2))
        self.selectedQuit.setSurface(sombra)


        #MENU 
        self.selected=1
        self.options=4 

        
    def paint(self):
        self.paintItem(self.core.fondo)
        self.paintItem(self.core.fondo2)
        self.paintItem(self.barra_superior)
        self.paintItem(self.titulo)


      
        if (self.selected == 1):
            self.paintItem(self.selectedResume)
        else:
            self.paintItem(self.resume)

        if (self.selected == 2):
            self.paintItem(self.selectedOpt)
        else:
            self.paintItem(self.opt)

        if (self.selected == 3):
            self.paintItem(self.selectedMainMenu)
        else:
            self.paintItem(self.mainmenu)
        
        if (self.selected == 4):
            self.paintItem(self.selectedQuit)
        else:
            self.paintItem(self.quit)
                
    def logic(self):
        self.core.fondo.ia()
        self.core.fondo2.ia()
        
    def controls(self):

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_DOWN)) > 0:
            self.selected += 1
            if self.selected > 4:
                self.selected = 1
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_DOWN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RIGHT)) > 0:
            self.selected += 1
            if self.selected > 4:
                self.selected = 1
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RIGHT)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_UP)) > 0:
            self.selected -= 1
            if self.selected < 1:
                self.selected = 4
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_UP)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_LEFT)) > 0:
            self.selected -= 1
            if self.selected < 1:
                self.selected = 4
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_LEFT)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 1:
            self.core.game = self.core.resumed
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))


        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 2:
            self.core.game = self.core.games[4]
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 3:
            self.core.game = self.core.games[0]
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selected == 4:
            self.core.controlManager.running = False
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))



    