###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import pygame
from lib import FileManager
from Game import Game
import os, sys
from game.intro.Fondo import Fondo
from lib.Shadows import *
from lib.SimpleSurface import SimpleSurface

class SelectMode(Game):
    """clase principal del menu del juego"""
    def __init__(self, core):
        Game.__init__(self,core)
        self.core = core
        #self.fondo = Fondo(self.core, (0,0))
        #self.fondo2 = Fondo(self.core, (self.core.screen_width, 0))
        
        self.barra_superior = SimpleSurface("game"+os.path.sep+"selectMode"+os.path.sep+"images"+os.path.sep+"barra_superior"+os.path.sep+"barra_superior.png")

        self.core.font.selectCustomFont("kimbalt_", 30)

        self.fuente = self.core.font.renderText("Modo de juego:", self.core.screen_width * 0.01, self.core.screen_height * 0.05, (0,153,255))
        nueva = add_shadow(self.fuente.getSurface(), (2,2))
        self.fuente.setSurface(nueva)

        self.core.font.selectCustomFont("kimbalt_", 14)

        self.info = self.core.font.renderText("Usa Arriba - Abajo o Izquierda - Derecha para navegar, ESC para volver atras", self.core.screen_width - self.core.screen_width * 0.01, self.core.screen_height * 0.01, (255,0,0), "right", "top")
        nuevainfo = add_shadow(self.info.getSurface(), (1,1))
        self.info.setSurface(nuevainfo)

        self.one = SimpleSurface("game"+os.path.sep+"selectMode"+os.path.sep+"images"+os.path.sep+"express"+os.path.sep+"express.png")
        self.two = SimpleSurface("game"+os.path.sep+"selectMode"+os.path.sep+"images"+os.path.sep+"free"+os.path.sep+"free.png")
        
        

        self.one_selected = SimpleSurface("game"+os.path.sep+"selectMode"+os.path.sep+"images"+os.path.sep+"express"+os.path.sep+"express.png")
        self.two_selected = SimpleSurface("game"+os.path.sep+"selectMode"+os.path.sep+"images"+os.path.sep+"free"+os.path.sep+"free.png")
        
        

        self.one_selected.setRect(self.core.screen_width * 0.30, self.core.screen_height * 0.50, "center", "center")
        self.two_selected.setRect(self.core.screen_width * 0.70, self.core.screen_height * 0.50, "center", "center")
        


        #if self.core.screen_height < self.fondo.max_rect().height:
        #reescalamos los botones para su correcta visualizacion
        self.one.setSurface(pygame.transform.smoothscale(self.one.getSurface(), (int(self.one.max_rect().width * 0.8), int(self.one.max_rect().height * 0.8))))
        self.two.setSurface(pygame.transform.smoothscale(self.two.getSurface(), (int(self.two.max_rect().width * 0.8), int(self.two.max_rect().height * 0.8))))
        

        
        #ponemos coordenadas a las imagenes
        self.one.setRect(self.core.screen_width * 0.30, self.core.screen_height * 0.50, "center", "center")
        self.two.setRect(self.core.screen_width * 0.70, self.core.screen_height * 0.50, "center", "center")
        


        
        self.selectedMode = 1


    def paint(self):
        self.paintItem(self.core.fondo)
        self.paintItem(self.core.fondo2)
        self.paintItem(self.barra_superior)
        self.paintItem(self.fuente)
        self.paintItem(self.info)

        if (self.selectedMode == 1):
            self.paintItem(self.one_selected)
        else:
            self.paintItem(self.one)

        if (self.selectedMode == 2):
            self.paintItem(self.two_selected)
        else:
            self.paintItem(self.two)




       
        

    def logic(self):

        self.core.fondo.ia()
        self.core.fondo2.ia()

    def controls(self):
        """rescatamos las funciones de mapeado general del juego y el resto lo delegamos al minijuego"""
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_DOWN)) > 0:
            self.selectedMode += 1
            if self.selectedMode > 2:
                self.selectedMode = 1
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_DOWN)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RIGHT)) > 0:
            self.selectedMode += 1
            if self.selectedMode > 2:
                self.selectedMode = 1
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RIGHT)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_UP)) > 0:
            self.selectedMode -= 1
            if self.selectedMode < 1:
                self.selectedMode = 2
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_UP)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_LEFT)) > 0:
            self.selectedMode -= 1
            if self.selectedMode < 1:
                self.selectedMode = 2
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_LEFT)))

        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_ESCAPE)) > 0:
            self.core.game = self.core.games[1]
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_ESCAPE)))


        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selectedMode == 1:
            self.core.game = self.core.games[3]
            self.core.game.setGameMode(1)
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))


        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.selectedMode == 2:
            self.core.game = self.core.games[3]
            self.core.game.setGameMode(2)
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))

			
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_f)) > 0:
            self.core.toggleFullScreen()
            self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_f)))

     
        
