###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import pygame,sys,os
from pygame.locals import *

class ControlManager(object):

    def __init__(self):

        self.action = None
        self.running = True
        self.controlEvents = []
        self.controlSimple = []
        self.joysticks = []
        self.initJoysticks()

    def initJoysticks(self):
        """metodo para comprobar si hay joysticks funcionando en el sistema y enlazarle los eventos"""
        numJoysticks  = pygame.joystick.get_count()
        if numJoysticks > 0:
            for i in xrange(0, numJoysticks):
                self.joysticks.append(pygame.joystick.Joystick(i))
                self.joysticks[i].init()
                print "joystick ",i, ": ", self.joysticks[i].get_name()


    def capture(self):

        for event in pygame.event.get():

            if event.type == pygame.QUIT:
                
                #Esta funcion debe ser redefinida para gestionar la salida del juego. Por defecto no hace nada
                self.manageExit()

                #rompe el bucle del juego y termina la ejecucion
                self.running = False

            else:
            
                if event.type == pygame.MOUSEBUTTONUP:
                    #captura tecla soltada del raton
                    self.controlEvents.remove(("MOUSEBUTTON", event.pos, event.button))

                if event.type == pygame.MOUSEBUTTONDOWN:
                    #captura tecla pulsada del raton
                    self.controlEvents.append(("MOUSEBUTTON", event.pos, event.button))

                #if event.type == pygame.MOUSEMOTION:
                    #if mouse movement is captured, execute an action in the assigned object with (pos, rel, buttons) parameter
                    #self.action.do(("MOUSEMOTION", event.pos, event.rel, event.buttons))
            
                if event.type == pygame.KEYUP:
                    #if key is captured, execute an action in the assigned object with key parameter
                    self.controlEvents.remove(("KEYBUTTON", event.key))

                if event.type == pygame.KEYDOWN:
                    #if key is captured, execute an action in the assigned object with key parameter
                    self.controlEvents.append(("KEYBUTTON", event.key))
                    #miramos si existe el evento en controlPressed para agregar otro evento keybutton
                    self.controlSimple.append(("KEYBUTTON", event.key))

                if event.type == pygame.JOYBUTTONUP:
                    #if key is captured, execute an action in the assigned object with key parameter
                    self.controlEvents.remove(("JOYBUTTON", event.joy, event.button))

                if event.type == pygame.JOYBUTTONDOWN:
                    #if key is captured, execute an action in the assigned object with key parameter
                    self.controlEvents.append(("JOYBUTTON", event.joy, event.button))


    def manageExit(self):
        pass

class ControlMapper(object):
    
    def __init__(self, controls):
        
        self.controls = controls

    def keyPressed(self, key):
        
        #pressed = pygame.key.get_pressed()
        #return pressed[key]
        if self.controls.count(("KEYBUTTON", key)) > 0:
            return True
        else:
            return False

    def joyPressed(self, joy, button):
        if self.controls.count(("JOYBUTTON", joy, button)) > 0:
            return True
        else:
            return False

        


