###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import os
import glob
import Parser
import re



def fileReader(location=''):
    """FileReader returns a list with the contents of the specified file found in Location"""

    content = []

    totalLoc = locationFixer(location)

    try:
        f = open(totalLoc, 'r')
        for line in f:

            cleanline = line.rstrip('\n')
            content.append(cleanline)

        f.close() 

    except IOError:
        #TODO:
        print "FileHandler.fileReader -> Archivo no encontrado"
        return -1
        
    return content


def dirReader(location='',dirfilter='a'):
    """DirReaderContent returns a list with the name of every element within the specified location.
        Its second argument is used as a filter, 'a' means all, 'd' means only directories and 
        f' means only files."""

    elements = []
    lastdir=os.getcwd() 

    fixedLoc = locationFixer(location)

    if os.path.exists(fixedLoc) and os.path.isdir(fixedLoc):

        os.chdir(fixedLoc)   
        content = glob.glob('*')
        for e in content:
            if (dirfilter=='a'): 
                cond = True  
            if (dirfilter=='d'):
                cond = os.path.isdir(e)
            if (dirfilter=='f'):
                cond = os.path.isfile(e)
            if (cond == True):
                elements.append(e)

    else: 
        return []


    os.chdir(lastdir) 
    return elements


def locationFixer(loc):

    """LocationFixer takes a path and using this file as reference, returns
    an absolute path to the root directory of arcadia."""

    #print "ORIGINAL LOCATION:  "+loc

    #This file is in Lib, one level above. Fix:
    loc="../"+loc
    #print "ONE LEVEL ABOVE:  "+loc

    #Directory of this file. Used as a reference.
    actualLoc = os.path.dirname(__file__)
    #print "CUSLARCADIA:  "+actualLoc
    
    #Now it is time to join both paths
    endLoc = os.path.normpath(os.path.join(actualLoc,loc))
    #print "FINAL LOCATION:  "+endLoc
    #print "--------------"
    
    if re.search(r'[\w\d]+\.exe', endLoc):
        endLoc=re.subn(r'[\w\d]+\.exe', r'', endLoc)[0]
        #print "        SUSTITUCION NECESARIA"

    return endLoc



def xmlReader(location=''):

    stringList=fileReader(location)

    if stringList==[]:
        return -1
    elif type(stringList)=='int':
        return -1
    elif stringList==-1:
        return -1
    else:
        string=""
        for e in stringList:
            string = string+e
        newParser = Parser.Parser()
        newParser.startParser(string)

        return newParser.results


def fileWriter(location='',content=''):

    loc=str(locationFixer(location))

    try:
        f = open(loc, 'w')

        f.write(content)

        f.close() 

    except IOError:
        return -1





#TODO: TESTING ---

if __name__ == "__main__":

 
    print xmlReader("../Escritorio/config.xml")
    


