###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

class GroupManager(object):
    """clase para manejar grupos de sprites"""
    def __init__(self):
        self.group = []

    def get(self):
        return self.group

    def add(self, sprite):
        self.group.append(sprite)

    def remove(self, sprite):
        self.group.remove(sprite)

    def copy (self):
        newgroup = []

        for sprite in self.group:
            newgroup.append(sprite)

        return newgroup

    def empty(self):
        self.group = []

    def contains(self, sprite):
        
        if self.group.count(sprite) > 0:
            return True
        else:
            return False

    def hide(self):
        for sprite in self.group:
            sprite.hide()

    def show(self):
        for sprite in self.group:
            sprite.show()

    def move(self,x ,y):
        for sprite in self.group:
            sprite.move(x,y)

    def subgroup(self, offset, size):
        """devuelve una sublista [offset : offset+size]"""

        if offset + size > len(self.group):

            return self.group[offset:]
        else:
            return self.group[offset : (offset+size)]
        


