import pygame
from lib import FileManager
from Game import Game

#Lo que necesites
from lib.Shadows import *
from lib.CollisionManager import CollisionManager
import lib.PhysicsManager

#Elementos
from minigames.apples.Fondo import Fondo
from minigames.apples.elements.Arcadio import Arcadio
from minigames.apples.elements.Movil import Movil


class MiniGame(Game):
    
    def __init__(self, core):
        Game.__init__(self,core)
        self.core = core
        self.startGame("apples")
        self.fondo = Fondo()
        self.fondo2 = Fondo()
        self.fondo2.initialPosition(0,600) #self.fondo.top+self.fondo.heigth


        
        self.arcadio = Arcadio()
        self.arcadio.mode="xAxis"
        self.manzana = Movil()
        self.manzana2 = Movil()

        self.manzana2.rect.left=self.manzana.rect.left+100


        self.end=False

        self.bindSpriteToControls(self.arcadio)
        self.collisions = CollisionManager()
        self.physic=lib.PhysicsManager.Physic(0,20,60)



        #FUENTE DE LETRA

        self.core.font.font=pygame.font.SysFont("Arial", 20)
        posx=self.core.screen_width * 0.1
        posy=self.core.screen_height * 0.1
        color=(255,0,0)

        self.info = self.core.font.renderText("Objetivo: Cuidado con las manzanas!", posx, posy, color, "left", "top")
        nuevainfo = add_shadow(self.info.getSurface(), (1,1))
        self.info.setSurface(nuevainfo)

        posx2=self.core.screen_width - self.core.screen_width * 0.1
        posy2=self.core.screen_height * 0.1
        color2=(0,255,0)

        self.info2 = self.core.font.renderText("Pulsa A y D -- B para reintentar", posx2, posy2, color2, "right", "top")
        nuevainfo2 = add_shadow(self.info2.getSurface(), (1,1))
        self.info2.setSurface(nuevainfo2)


        self.infoGanar = self.core.font.renderText("Ganaste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (0,0,30), "left", "top")
        self.infoGanar.setSurface(add_shadow(self.infoGanar.getSurface(), (1,1)))

        self.infoPerder = self.core.font.renderText("Perdiste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (255,0,0), "left", "top")
        self.infoPerder.setSurface(add_shadow(self.infoPerder.getSurface(), (1,1)))


    def paint(self):

        #Capa 1: FONDO
        self.paintItem(self.fondo)
        self.paintItem(self.fondo2)

        #Capa 2: Bichos
        self.paintItem(self.arcadio)
        self.paintItem(self.manzana)
        self.paintItem(self.manzana2)
     

        #Capa 3: HUB
        self.paintItem(self.info)
        self.paintItem(self.info2)

        if self.end==True:
            self.paintItem(self.message)

        self.paintItem(self.startSurface)


        self.paintElements()
        
    def logic(self):
        

        col=False
        colision = self.collisions.rectangleCollision(self.arcadio, self.manzana) or self.collisions.rectangleCollision(self.arcadio, self.manzana2)

        colisionlados= self.collisions.edgeCollision(self.arcadio, self.manzana)
        colisionlados.append(self.collisions.edgeCollision(self.arcadio, self.manzana))
        if colision:
            col=True
        if len(colisionlados)>0:
            if col:
                self.arcadio.colisionado() 
                self.end=True
                self.message=self.infoPerder
        col=False
            

        self.manzana.move(self.manzana.left,self.manzana.top+10)
        if self.manzana.rect.top>=800:
            self.manzana.rect.top=0
        self.manzana2.move(self.manzana2.left,self.manzana2.top+20)
        if self.manzana2.rect.top>=800:
            self.manzana2.rect.top=0





        if self.arcadio.rect.left>500:
            self.end=True
            self.message=self.infoGanar


        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_f)) > 0:
            self.core.toggleFullScreen()


        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_b)) > 0:
            self.end=False
            self.arcadio.rect.left=100
            self.arcadio.show()

        





