import pygame
from pygame.locals import *
from lib.SpriteManager import SpriteManager


class Arcadio2(SpriteManager):

    def __init__(self,core=None):

        self.core=core
        SpriteManager.__init__(self)
        self.loadSprites()
        self.defaultSurface(self.move_left)
        self.initialPosition(100,300)
        self.velocity = 10

        self.mode=None
        self.turno=0

    def loadSprites(self):
        self.move_left = self.getAnimation('resources/test/andar-izquierda', 'left')
        self.move_right = self.getAnimation('resources/test/andar-izquierda', 'right', True)
        self.move_up = self.getAnimation('resources/test/andar-arriba', 'up')
        self.move_down = self.getAnimation('resources/test/andar-abajo', 'down')
        self.agacharse = self.getAnimation('resources/test/agacharse', 'agacharse')


    def moveLeft(self):
        self.move(-self.velocity,0)
        self.surface = self.animate(self.move_left)
        

    def moveRight(self):
        self.move(self.velocity,0)
        self.surface = self.animate(self.move_right)
        

    def moveUp(self):
        self.move(0,-self.velocity)
        self.surface = self.animate(self.move_up)

    def moveDown(self):
        self.move(0,self.velocity)
        self.surface = self.animate(self.move_down)

    def colisionado(self):
        self.surface = self.animate(self.agacharse)
        self.hide()


    def controls(self, controls):

        controlx=0
        controly=0

        if self.core==None:
            if controls.keyPressed(K_UP):
                
                if controly==0:
                    controly=-1
                    controlx=0+1*controls.keyPressed(K_RIGHT)-1*controls.keyPressed(K_LEFT)
                
            if controls.keyPressed(K_DOWN):
                
                if controly==0:
                    controly=+1
                    controlx=0+1*controls.keyPressed(K_RIGHT)-1*controls.keyPressed(K_LEFT)

            if controls.keyPressed(K_RIGHT):
                if controlx==0:
                    controlx=1
            if controls.keyPressed(K_LEFT):
                if controlx==0:
                    controlx=-1

        else:
  
            if controls.keyPressed(self.core.configManager.getKey(1,"up")):
                    
                if controly==0:
                    controly=-1
                    controlx=0+1*controls.keyPressed(self.core.configManager.getKey(1,"right"))-1*controls.keyPressed(self.core.configManager.getKey(1,"left"))
                    
            if controls.keyPressed(self.core.configManager.getKey(1,"down")):
                    
                if controly==0:
                    controly=+1
                    controlx=0+1*controls.keyPressed(self.core.configManager.getKey(1,"right"))-1*controls.keyPressed(self.core.configManager.getKey(1,"left"))
    
            if controls.keyPressed(self.core.configManager.getKey(1,"right")):
                if controlx==0:
                    controlx=1
            if controls.keyPressed(self.core.configManager.getKey(1,"left")):
                if controlx==0:
                    controlx=-1
    
                    
    
        if controlx==+1:
            self.moveRight()
        elif controlx==-1:
            self.moveLeft()
        if controly==+1:
            self.moveDown()
        elif controly==-1:
                self.moveUp()




